'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.replaceWithSafeCall = replaceWithSafeCall;

var _types = require('./types');

var _types2 = _interopRequireDefault(_types);

var _ref = require('./ref');

var _is = require('./is');

var _is2 = _interopRequireDefault(_is);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function replaceWithSafeCall(path, callExpr) {
  var callee = void 0,
      typeofExpr = void 0;

  if ((0, _is2.default)("MemberExpression", callExpr.callee)) {
    var memberExpr = callExpr.callee;

    var _hoistRef = (0, _ref.hoistRef)(path, memberExpr.object, "obj"),
        objectRef = _hoistRef.ref,
        object = _hoistRef.assign;

    var property = memberExpr.property,
        propertyRef = memberExpr.property;
    if (memberExpr.computed) {
      var _hoistRef2 = (0, _ref.hoistRef)(path, memberExpr.property, "prop");

      propertyRef = _hoistRef2.ref;
      property = _hoistRef2.assign;
    }

    typeofExpr = _types2.default.memberExpression(object, property, memberExpr.computed);
    callee = _types2.default.memberExpression(objectRef, propertyRef, memberExpr.computed);
  } else {
    var _hoistRef3 = (0, _ref.hoistRef)(path, callExpr.callee);

    callee = _hoistRef3.ref;
    typeofExpr = _hoistRef3.assign;
  }

  // Generate actual safecall expr
  // f?(x) -> (typeof f === "function") ? f(x) : null
  return path.replaceWith(_types2.default.conditionalExpression(_types2.default.binaryExpression("===", _types2.default.unaryExpression("typeof", typeofExpr), _types2.default.stringLiteral("function")), _types2.default.callExpression(callee, callExpr.arguments), _types2.default.nullLiteral()));
}